Index: /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 5840)
+++ /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 5841)
@@ -16,4 +16,6 @@
    !!  -   !  2013-05  (A. Yool)              updated for v3.5
    !!  -   !  2014-08  (A. Yool, J. Palm)     Add DMS module for UKESM1 model
+   !!  -   !  2015-06  (A. Yool)              Update to include MOCSY
+   !!  -   !  2015-07  (A. Yool)              Update for rolling averages
    !!----------------------------------------------------------------------
    !!
@@ -36,4 +38,17 @@
 #endif
    !!
+#if defined key_mocsy
+   !!----------------------------------------------------------------------
+   !! Updates with the addition of MOCSY include:
+   !!   - option to use PML or MOCSY carbonate chemistry (the latter is 
+   !!     preferred)
+   !!   - central calculation of gas transfer velocity, f_kw660; previously
+   !!     this was done separately for CO2 and O2 with predictable results
+   !!   - distribution of f_kw660 to both PML and MOCSY CO2 air-sea flux 
+   !!     calculations and to those for O2 air-sea flux
+   !!   - extra diagnostics included for MOCSY
+   !!----------------------------------------------------------------------
+#endif
+   !!
 #if defined key_medusa
    !!----------------------------------------------------------------------
@@ -55,5 +70,10 @@
 # endif
 # if defined key_roam
+      USE gastransfer
+#  if defined key_mocsy
+      USE mocsy_wrapper
+#  else
       USE trcco2_medusa
+#  endif
       USE trcoxy_medusa
       !! Jpalm (08/08/2014)
@@ -134,4 +154,7 @@
       REAL(wp) ::    ztmp, zsal
 # endif
+# if defined key_mocsy
+      REAL(wp) ::    zpho
+# endif
       !!
       !! integrated source and sink terms
@@ -266,4 +289,9 @@
       REAL(wp) ::    f_kw660, f_o2flux, f_o2sat
       REAL(wp), DIMENSION(jpi,jpj) ::    f_omcal, f_omarg
+      !!
+      !! AXY (23/06/15): additional diagnostics for MOCSY and oxygen
+      REAL(wp) ::    f_fco2w, f_BetaD, f_rhosw, f_opres, f_insitut, f_pco2atm, f_fco2atm
+      REAL(wp) ::    f_schmidtco2, f_kwco2, f_K0, f_co2starair, f_dpco2, f_kwo2
+      !!
       INTEGER  ::    iters
       REAL(wp) ::    f_year
@@ -305,4 +333,9 @@
 
       !!---------------------------------------------------------------------
+
+# if defined key_debug_medusa
+      IF (lwp) write (numout,*) 'trc_bio_medusa: variables defined'
+      CALL flush(numout)
+# endif 
 
       !! AXY (20/11/14): alter this to report on first MEDUSA call
@@ -486,4 +519,9 @@
 # endif
 
+# if defined key_debug_medusa
+      IF (lwp) write (numout,*) 'trc_bio_medusa: variables initialised and checked'
+      CALL flush(numout)
+# endif 
+
 # if defined key_roam
       !!----------------------------------------------------------------------
@@ -514,8 +552,7 @@
          f_pco2a = fq4
       endif
-# if defined key_axy_pi_co2
+#  if defined key_axy_pi_co2
       f_pco2a = hist_pco2(1)
-      IF(lwp) WRITE(numout,*) ' MEDUSA atm pCO2  = FIXED'
-# endif
+#  endif
       !! IF(lwp) WRITE(numout,*) ' MEDUSA nyear     =', nyear
       !! IF(lwp) WRITE(numout,*) ' MEDUSA nsec_day  =', real(nsec_day)
@@ -529,8 +566,17 @@
 # endif
 
+# if defined key_debug_medusa
+      IF (lwp) write (numout,*) 'trc_bio_medusa: ready for carbonate chemistry'
+      IF (lwp) write (numout,*) 'trc_bio_medusa: kt = ', kt
+      IF (lwp) write (numout,*) 'trc_bio_medusa: nittrc000 = ', nittrc000
+      CALL flush(numout)
+# endif 
+
 # if defined key_roam
-      !! AXY (20/11/14): alter to call on first MEDUSA timestep
+      !! AXY (20/11/14): alter to call on first MEDUSA timestep and then every
+      !!                 month (this is hardwired as 960 timesteps but should
+      !!                 be calculated and done properly
       !! IF( kt == nit000 .or. mod(kt,1920) == 0 ) THEN
-      IF( kt == nittrc000 .or. mod(kt,1920) == 0 ) THEN
+      IF( kt == nittrc000 .or. mod(kt,960) == 0 ) THEN
          !!----------------------------------------------------------------------
          !! Calculate the carbonate chemistry for the whole ocean on the first
@@ -540,4 +586,5 @@
          !!
          IF(lwp) WRITE(numout,*) ' MEDUSA calculating all carbonate chemistry at kt =', kt
+         CALL flush(numout)
          !! blank flags
          i2_omcal(:,:) = 0
@@ -549,6 +596,8 @@
                   !! OPEN wet point IF..THEN loop
                   if (tmask(ji,jj,jk).eq.1) then
-                     !! carbonate chemistry
+                     !! do carbonate chemistry
+                     !!
                      fdep2 = fsdept(ji,jj,jk)           !! set up level midpoint
+                     !!
                      !! set up required state variables
                      zdic = max(0.,trn(ji,jj,jk,jpdic)) !! dissolved inorganic carbon
@@ -556,4 +605,8 @@
                      ztmp = tsn(ji,jj,jk,jp_tem)        !! temperature
                      zsal = tsn(ji,jj,jk,jp_sal)        !! salinity
+#  if defined key_mocsy
+                     zsil = max(0.,trn(ji,jj,jk,jpsil))        !! silicic acid
+                     zpho = max(0.,trn(ji,jj,jk,jpdin)) / 16.0 !! phosphate via DIN and Redfield
+#  endif
 		     !!
 		     !! AXY (28/02/14): check input fields
@@ -571,7 +624,28 @@
                         ji, ',', jj, ',', jk, ') at time', kt
                      endif
+                     !!
+                     !! blank input variables not used at this stage (they relate to air-sea flux)
+                     f_kw660 = 1.0
+                     f_pp0   = 1.0
+                     !!
                      !! calculate carbonate chemistry at grid cell midpoint
-                     CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, fdep2, 5.0, f_pco2a, &    ! inputs
-                     f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),            &    ! outputs
+#  if defined key_mocsy
+                     !! AXY (22/06/15): use Orr & Epitalon (2015) MOCSY-2 carbonate
+                     !!                 chemistry package
+                     CALL mocsy_interface( ztmp, zsal, zalk, zdic, zsil, zpho,         &    ! inputs
+                     f_pp0, fdep2, flatx, f_kw660, f_pco2a, 1,                         &    ! inputs
+                     f_ph, f_pco2w, f_fco2w, f_h2co3, f_hco3, f_co3, f_omarg(ji,jj),   &    ! outputs
+                     f_omcal(ji,jj), f_BetaD, f_rhosw, f_opres, f_insitut,             &    ! outputs
+                     f_pco2atm, f_fco2atm, f_schmidtco2, f_kwco2, f_K0,                &    ! outputs
+                     f_co2starair, f_co2flux, f_dpco2 )                                     ! outputs
+                     !!
+                     f_TDIC = (zdic / f_rhosw) * 1000. ! mmol / m3 -> umol / kg
+                     f_TALK = (zalk / f_rhosw) * 1000. !  meq / m3 ->  ueq / kg
+                     f_dcf  = f_rhosw
+#  else
+                     !! AXY (22/06/15): use old PML carbonate chemistry package (the
+                     !!                 MEDUSA-2 default)
+                     CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, fdep2, f_kw660,      &    ! inputs
+                     f_pco2a, f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),   &    ! outputs
                      f_omarg(ji,jj), f_co2flux, f_TDIC, f_TALK, f_dcf, f_henry, iters)      ! outputs
                      !! 
@@ -581,4 +655,6 @@
                         iters, ' AT (', ji, ', ', jj, ', ', jk, ') AT ', kt
                      endif
+#  endif
+                     !!
                      !! store 3D outputs
                      f3_pH(ji,jj,jk)    = f_ph
@@ -588,4 +664,5 @@
                      f3_omcal(ji,jj,jk) = f_omcal(ji,jj)
                      f3_omarg(ji,jj,jk) = f_omarg(ji,jj)
+                     !!
                      !! CCD calculation: calcite
                      if (i2_omcal(ji,jj) .eq. 0 .and. f_omcal(ji,jj) .lt. 1.0) then
@@ -607,4 +684,5 @@
                         i2_omcal(ji,jj)   = 1
                      endif
+                     !!
                      !! CCD calculation: aragonite
                      if (i2_omarg(ji,jj) .eq. 0 .and. f_omarg(ji,jj) .lt. 1.0) then
@@ -633,4 +711,9 @@
 # endif
 
+# if defined key_debug_medusa
+      IF (lwp) write (numout,*) 'trc_bio_medusa: ready for full domain calculations'
+      CALL flush(numout)
+# endif 
+
       !!----------------------------------------------------------------------
       !! MEDUSA has unified equation through the water column
@@ -656,5 +739,4 @@
             !! OPEN wet point IF..THEN loop
             if (tmask(ji,jj,jk).eq.1) then               
-
                !!======================================================================
                !! SETUP LOCAL GRID CELL
@@ -814,7 +896,4 @@
                   !!----------------------------------------------------------------------
                   !!
-                  !! a bit of set up ...
-                  ! f_uwind = zwnd_i(ji,jj)
-                  ! f_vwind = zwnd_j(ji,jj)
                   !! AXY (17/07/14): zwind_i and zwind_j do not exist in this
                   !!                 version of NEMO because it does not include
@@ -827,22 +906,32 @@
                   !!                 revisited when MEDUSA properly interacts
                   !!                 with UKESM1 physics
-                  ! f_uwind = zwind_i(ji,jj)
-                  ! f_vwind = zwind_j(ji,jj)
-                  ! f_wind  = ((f_uwind**2.0) + (f_vwind**2.0))**0.5
+                  !!
                   f_wind  = wndm(ji,jj)
-                  !! AXY (17/07/14): the current oxygen code takes in separate
-                  !!                 U and V components of the wind; to avoid
-                  !!                 the need to change this, calculate these
-                  !!                 components based on wndm; again, this is
-                  !!                 not ideal, but should suffice as a
-                  !!                 temporary measure; in the long-term all
-                  !!                 of MEDUSA's air-sea gas exchange terms
-                  !!                 will be revisited to ensure that they are
-                  !!                 valid and self-consistent; and the CO2
-                  !!                 code will be wholly replaced with a more
-                  !!                 up-to-date parameterisation
-                  f_uwind = ((f_wind**2.0) / 2.0)**0.5
-                  f_vwind = f_uwind
+                  !!
+                  !! AXY (23/06/15): as part of an effort to update the carbonate chemistry
+                  !!                 in MEDUSA, the gas transfer velocity used in the carbon
+                  !!                 and oxygen cycles has been harmonised and is calculated
+                  !!                 by the same function here; this harmonisation includes
+                  !!                 changes to the PML carbonate chemistry scheme so that
+                  !!                 it too makes use of the same gas transfer velocity; the
+                  !!                 preferred parameterisation of this is Wanninkhof (2014),
+                  !!                 option 7
+                  !!
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: entering gas_transfer'
+                     CALL flush(numout)
+#   endif
+                  CALL gas_transfer( f_wind, 1, 7, &  ! inputs
+                                     f_kw660 )        ! outputs
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: exiting gas_transfer'
+                     CALL flush(numout)
+#   endif
+                  !!
+                  !! air pressure (atm); ultimately this will use air pressure at the base
+                  !! of the UKESM1 atmosphere 
+                  !!                                     
                   f_pp0   = 1.0
+                  !!
                   !! IF(lwp) WRITE(numout,*) ' MEDUSA ztmp    =', ztmp
                   !! IF(lwp) WRITE(numout,*) ' MEDUSA zwind_i =', zwind_i(ji,jj)
@@ -852,10 +941,26 @@
                   !!
 #  if defined key_axy_carbchem
+#   if defined key_mocsy
+                  !!
+                  !! AXY (22/06/15): use Orr & Epitalon (2015) MOCSY-2 carbonate
+                  !!                 chemistry package; note that depth is set to
+                  !!                 zero in this call
+                  CALL mocsy_interface( ztmp, zsal, zalk, zdic, zsil, zpho,        &  ! inputs
+                  f_pp0, 0.0, flatx, f_kw660, f_pco2a, 1,                          &  ! inputs
+                  f_ph, f_pco2w, f_fco2w, f_h2co3, f_hco3, f_co3, f_omarg(ji,jj),  &  ! outputs
+                  f_omcal(ji,jj), f_BetaD, f_rhosw, f_opres, f_insitut,            &  ! outputs
+                  f_pco2atm, f_fco2atm, f_schmidtco2, f_kwco2, f_K0,               &  ! outputs
+                  f_co2starair, f_co2flux, f_dpco2 )                                  ! outputs
+                  !!
+                  f_TDIC = (zdic / f_rhosw) * 1000. ! mmol / m3 -> umol / kg
+                  f_TALK = (zalk / f_rhosw) * 1000. !  meq / m3 ->  ueq / kg
+                  f_dcf  = f_rhosw
+#   else                  
                   iters = 0
                   !!
                   !! carbon dioxide (CO2); Jerry Blackford code (ostensibly OCMIP-2, but not)
-                  CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, 0.0, f_wind, f_pco2a, &     ! inputs
-                  f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),             &     ! outputs
-                  f_omarg(ji,jj), f_co2flux, f_TDIC, f_TALK, f_dcf, f_henry, iters )       ! outputs
+                  CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, 0.0, f_kw660, f_pco2a,  &  ! inputs
+                  f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),               &  ! outputs
+                  f_omarg(ji,jj), f_co2flux, f_TDIC, f_TALK, f_dcf, f_henry, iters )      ! outputs
                   !!
                   !! AXY (09/01/14): removed iteration and NaN checks; these have
@@ -869,4 +974,5 @@
                      iters, ' AT (', ji, ', ', jj, ', ', jk, ') AT ', kt
                   endif
+#   endif
 #  else
                   !! AXY (18/04/13): switch off carbonate chemistry calculations; provide
@@ -882,18 +988,34 @@
                   f_TDIC         = zdic
                   f_TALK         = zalk
-                  f_dcf          = 1.
+                  f_dcf          = 1.026
                   f_henry        = 1.
+                  !! AXY (23/06/15): add in some extra MOCSY diagnostics
+                  f_fco2w        = fpco2a
+                  f_BetaD        = 1.
+                  f_rhosw        = 1.026
+                  f_opres        = 0.
+                  f_insitut      = ztmp
+                  f_pco2atm      = fpco2a
+                  f_fco2atm      = fpco2a
+                  f_schmidtco2   = 660.
+                  f_kwco2        = 0.
+                  f_K0           = 0.
+                  f_co2starair   = fpco2a
+                  f_dpco2        = 0.
 #  endif
                   !!
-                  !! already in right units; correct for sea-ice; divide through by layer thickness
-                  f_co2flux = (1. - fr_i(ji,jj)) * f_co2flux / fthk
+                  !! mmol/m2/s -> mmol/m3/d; correct for sea-ice; divide through by layer thickness
+                  f_co2flux = (1. - fr_i(ji,jj)) * f_co2flux * 86400. / fthk
                   !!
                   !! oxygen (O2); OCMIP-2 code
-                  CALL trc_oxy_medusa( ztmp, zsal, f_uwind, f_vwind, f_pp0, zoxy / 1000., fthk, &  ! inputs
-                  f_kw660, f_o2flux, f_o2sat )                                                     ! outputs
-                  !!
-                  !! mol/m3/s -> mmol/m3/d; correct for sea-ice
-                  f_o2flux  = (1. - fr_i(ji,jj)) * f_o2flux * 1000. * 60. * 60. * 24. 
-                  f_o2sat   = f_o2sat  * 1000.
+                  !! AXY (23/06/15): amend input list for oxygen to account for common gas
+                  !!                 transfer velocity
+                  !! CALL trc_oxy_medusa( ztmp, zsal, f_uwind, f_vwind, f_pp0, zoxy / 1000., fthk,  &  ! inputs
+                  !! f_kw660, f_o2flux, f_o2sat )                                                      ! outputs
+                  CALL trc_oxy_medusa( ztmp, zsal, f_kw660, f_pp0, zoxy,  &  ! inputs
+                  f_kwo2, f_o2flux, f_o2sat )                                ! outputs
+                  !!
+                  !! mmol/m2/s -> mol/m3/d; correct for sea-ice; divide through by layer thickness
+                  f_o2flux  = (1. - fr_i(ji,jj)) * f_o2flux * 86400. / fthk
                   !!
                   !! Jpalm (08-2014)
@@ -911,9 +1033,27 @@
                   !!
                   IF (jdms .eq. 1) THEN
-                  !!
-                     !! CALL trc_dms_medusa( zchn, zchd, hmld(ji,jj), &                            !! inputs
-                     !! dms_surf )                                                                 !! outputs
-                     CALL trc_dms_medusa( zchn, zchd, hmld(ji,jj), qsr(ji,jj), zdin, &             !! inputs
-                     dms_surf, dms_andr, dms_simo, dms_aran, dms_hall )                            !! outputs
+                     !!
+                     !! feed in correct inputs
+                     if (jdms_input .eq. 0) then
+                        !! use instantaneous inputs
+                        CALL trc_dms_medusa( zchn, zchd, hmld(ji,jj), qsr(ji,jj), zdin, &  ! inputs
+                        dms_andr, dms_simo, dms_aran, dms_hall )                           ! outputs
+                     else
+                        !! use diel-average inputs
+                        CALL trc_dms_medusa( zn_dms_chn(ji,jj), zn_dms_chd(ji,jj), &  ! inputs
+                        zn_dms_mld(ji,jj), zn_dms_qsr(ji,jj), zn_dms_din(ji,jj),   &  ! inputs
+                        dms_andr, dms_simo, dms_aran, dms_hall )                      ! outputs
+                     endif
+                     !!
+                     !! assign correct output to variable passed to atmosphere
+                     if     (jdms_model .eq. 1) then
+                        dms_surf = dms_andr
+                     elseif (jdms_model .eq. 2) then
+                        dms_surf = dms_simo
+                     elseif (jdms_model .eq. 3) then
+                        dms_surf = dms_aran
+                     elseif (jdms_model .eq. 4) then
+                        dms_surf = dms_hall
+                     endif
                   ENDIF
                   !! End DMS Loop
@@ -953,5 +1093,5 @@
                   !! alkalinity are derived from continent-scale DIC estimates (Huang et al., 
                   !! 2012) and some Arctic river alkalinity estimates (Katya?)
-                  !!      
+                  !! 
                   !! as of 19/07/12, riverine nutrients can now be spread vertically across 
                   !! several grid cells rather than just poured into the surface box; this
@@ -3317,4 +3457,12 @@
          ENDDO
       ENDDO
+      !! AXY (07/07/15): temporary hijacking
+# if defined key_roam
+      trc2d(:,:,126) = zn_dms_chn(:,:)
+      trc2d(:,:,127) = zn_dms_chd(:,:)
+      trc2d(:,:,128) = zn_dms_mld(:,:)
+      trc2d(:,:,129) = zn_dms_qsr(:,:)
+      trc2d(:,:,130) = zn_dms_din(:,:)
+# endif
 
       if (ibenthic.eq.2) then
@@ -3322,105 +3470,105 @@
          !! effectively commented out because it does not work as 
          !! anticipated; it can be deleted at a later date
-      if (jorgben.eq.1) then
-         za_sed_n(:,:)  = ( f_sbenin_n(:,:)  + f_fbenin_n(:,:)  - f_benout_n(:,:)  ) * rdt
-         za_sed_fe(:,:) = ( f_sbenin_fe(:,:) + f_fbenin_fe(:,:) - f_benout_fe(:,:) ) * rdt
-         za_sed_c(:,:)  = ( f_sbenin_c(:,:)  + f_fbenin_c(:,:)  - f_benout_c(:,:)  ) * rdt
-      endif
-      if (jinorgben.eq.1) then
-         za_sed_si(:,:) = ( f_fbenin_si(:,:) - f_benout_si(:,:) ) * rdt
-         za_sed_ca(:,:) = ( f_fbenin_ca(:,:) - f_benout_ca(:,:) ) * rdt
-      endif
-      !!
-      !! Leap-frog scheme - only in explicit case, otherwise the time stepping
-      !! is already being done in trczdf
-      !! IF( l_trczdf_exp .AND. (ln_trcadv_cen2 .OR. ln_trcadv_tvd) ) THEN
-      !!    zfact = 2. * rdttra(jk) * FLOAT( ndttrc )
-      !!    IF( neuler == 0 .AND. kt == nittrc000 )   zfact = rdttra(jk) * FLOAT(ndttrc)
-      !!    if (jorgben.eq.1) then
-      !!       za_sed_n(:,:)  = zb_sed_n(:,:)  + ( zfact * za_sed_n(:,:)  )
-      !!      za_sed_fe(:,:) = zb_sed_fe(:,:) + ( zfact * za_sed_fe(:,:) )
-      !!       za_sed_c(:,:)  = zb_sed_c(:,:)  + ( zfact * za_sed_c(:,:)  )
-      !!    endif
-      !!    if (jinorgben.eq.1) then
-      !!       za_sed_si(:,:) = zb_sed_si(:,:) + ( zfact * za_sed_si(:,:) )
-      !!       za_sed_ca(:,:) = zb_sed_ca(:,:) + ( zfact * za_sed_ca(:,:) )
-      !!    endif
-      !! ENDIF
-      !! 
-      !! Time filter and swap of arrays
-      IF( ln_trcadv_cen2 .OR. ln_trcadv_tvd  ) THEN         ! centred or tvd scheme
-         IF( neuler == 0 .AND. kt == nittrc000 ) THEN
+         if (jorgben.eq.1) then
+            za_sed_n(:,:)  = ( f_sbenin_n(:,:)  + f_fbenin_n(:,:)  - f_benout_n(:,:)  ) * rdt
+            za_sed_fe(:,:) = ( f_sbenin_fe(:,:) + f_fbenin_fe(:,:) - f_benout_fe(:,:) ) * rdt
+            za_sed_c(:,:)  = ( f_sbenin_c(:,:)  + f_fbenin_c(:,:)  - f_benout_c(:,:)  ) * rdt
+         endif
+         if (jinorgben.eq.1) then
+            za_sed_si(:,:) = ( f_fbenin_si(:,:) - f_benout_si(:,:) ) * rdt
+            za_sed_ca(:,:) = ( f_fbenin_ca(:,:) - f_benout_ca(:,:) ) * rdt
+         endif
+         !!
+         !! Leap-frog scheme - only in explicit case, otherwise the time stepping
+         !! is already being done in trczdf
+         !! IF( l_trczdf_exp .AND. (ln_trcadv_cen2 .OR. ln_trcadv_tvd) ) THEN
+         !!    zfact = 2. * rdttra(jk) * FLOAT( ndttrc )
+         !!    IF( neuler == 0 .AND. kt == nittrc000 )   zfact = rdttra(jk) * FLOAT(ndttrc)
+         !!    if (jorgben.eq.1) then
+         !!       za_sed_n(:,:)  = zb_sed_n(:,:)  + ( zfact * za_sed_n(:,:)  )
+         !!      za_sed_fe(:,:) = zb_sed_fe(:,:) + ( zfact * za_sed_fe(:,:) )
+         !!       za_sed_c(:,:)  = zb_sed_c(:,:)  + ( zfact * za_sed_c(:,:)  )
+         !!    endif
+         !!    if (jinorgben.eq.1) then
+         !!       za_sed_si(:,:) = zb_sed_si(:,:) + ( zfact * za_sed_si(:,:) )
+         !!       za_sed_ca(:,:) = zb_sed_ca(:,:) + ( zfact * za_sed_ca(:,:) )
+         !!    endif
+         !! ENDIF
+         !! 
+         !! Time filter and swap of arrays
+         IF( ln_trcadv_cen2 .OR. ln_trcadv_tvd  ) THEN ! centred or tvd scheme
+            IF( neuler == 0 .AND. kt == nittrc000 ) THEN
+               if (jorgben.eq.1) then
+                  zb_sed_n(:,:)  = zn_sed_n(:,:)
+                  zn_sed_n(:,:)  = za_sed_n(:,:)
+                  za_sed_n(:,:)  = 0.0
+                  !!
+                  zb_sed_fe(:,:) = zn_sed_fe(:,:)
+                  zn_sed_fe(:,:) = za_sed_fe(:,:)
+                  za_sed_fe(:,:) = 0.0
+                  !!
+                  zb_sed_c(:,:)  = zn_sed_c(:,:)
+                  zn_sed_c(:,:)  = za_sed_c(:,:)
+                  za_sed_c(:,:)  = 0.0
+               endif
+               if (jinorgben.eq.1) then
+                  zb_sed_si(:,:) = zn_sed_si(:,:)
+                  zn_sed_si(:,:) = za_sed_si(:,:)
+                  za_sed_si(:,:) = 0.0
+                  !!
+                  zb_sed_ca(:,:) = zn_sed_ca(:,:)
+                  zn_sed_ca(:,:) = za_sed_ca(:,:)
+                  za_sed_ca(:,:) = 0.0
+               endif
+            ELSE
+               if (jorgben.eq.1) then
+                  zb_sed_n(:,:)  = (atfp  * ( zb_sed_n(:,:)  + za_sed_n(:,:)  )) + (atfp1 * zn_sed_n(:,:) )
+                  zn_sed_n(:,:)  = za_sed_n(:,:)
+                  za_sed_n(:,:)  = 0.0
+                  !!
+                  zb_sed_fe(:,:) = (atfp  * ( zb_sed_fe(:,:) + za_sed_fe(:,:) )) + (atfp1 * zn_sed_fe(:,:))
+                  zn_sed_fe(:,:) = za_sed_fe(:,:)
+                  za_sed_fe(:,:) = 0.0
+                  !!
+                  zb_sed_c(:,:)  = (atfp  * ( zb_sed_c(:,:)  + za_sed_c(:,:)  )) + (atfp1 * zn_sed_c(:,:) )
+                  zn_sed_c(:,:)  = za_sed_c(:,:)
+                  za_sed_c(:,:)  = 0.0
+               endif
+               if (jinorgben.eq.1) then
+                  zb_sed_si(:,:) = (atfp  * ( zb_sed_si(:,:) + za_sed_si(:,:) )) + (atfp1 * zn_sed_si(:,:))
+                  zn_sed_si(:,:) = za_sed_si(:,:)
+                  za_sed_si(:,:) = 0.0
+                  !!
+                  zb_sed_ca(:,:) = (atfp  * ( zb_sed_ca(:,:) + za_sed_ca(:,:) )) + (atfp1 * zn_sed_ca(:,:))
+                  zn_sed_ca(:,:) = za_sed_ca(:,:)
+                  za_sed_ca(:,:) = 0.0
+               endif
+            ENDIF
+         ELSE                   !  case of smolar scheme or muscl
             if (jorgben.eq.1) then
-               zb_sed_n(:,:)  = zn_sed_n(:,:)
+               zb_sed_n(:,:)  = za_sed_n(:,:)
                zn_sed_n(:,:)  = za_sed_n(:,:)
                za_sed_n(:,:)  = 0.0
                !!
-               zb_sed_fe(:,:) = zn_sed_fe(:,:)
+               zb_sed_fe(:,:) = za_sed_fe(:,:)
                zn_sed_fe(:,:) = za_sed_fe(:,:)
                za_sed_fe(:,:) = 0.0
                !!
-               zb_sed_c(:,:)  = zn_sed_c(:,:)
+               zb_sed_c(:,:)  = za_sed_c(:,:)
                zn_sed_c(:,:)  = za_sed_c(:,:)
                za_sed_c(:,:)  = 0.0
             endif
             if (jinorgben.eq.1) then
-               zb_sed_si(:,:) = zn_sed_si(:,:)
+               zb_sed_si(:,:) = za_sed_si(:,:)
                zn_sed_si(:,:) = za_sed_si(:,:)
                za_sed_si(:,:) = 0.0
                !!
-               zb_sed_ca(:,:) = zn_sed_ca(:,:)
-               zn_sed_ca(:,:) = za_sed_ca(:,:)
-               za_sed_ca(:,:) = 0.0
-            endif
-         ELSE
-            if (jorgben.eq.1) then
-               zb_sed_n(:,:)  = (atfp  * ( zb_sed_n(:,:)  + za_sed_n(:,:)  )) + (atfp1 * zn_sed_n(:,:) )
-               zn_sed_n(:,:)  = za_sed_n(:,:)
-               za_sed_n(:,:)  = 0.0
-               !!
-               zb_sed_fe(:,:) = (atfp  * ( zb_sed_fe(:,:) + za_sed_fe(:,:) )) + (atfp1 * zn_sed_fe(:,:))
-               zn_sed_fe(:,:) = za_sed_fe(:,:)
-               za_sed_fe(:,:) = 0.0
-               !!
-               zb_sed_c(:,:)  = (atfp  * ( zb_sed_c(:,:)  + za_sed_c(:,:)  )) + (atfp1 * zn_sed_c(:,:) )
-               zn_sed_c(:,:)  = za_sed_c(:,:)
-               za_sed_c(:,:)  = 0.0
-            endif
-            if (jinorgben.eq.1) then
-               zb_sed_si(:,:) = (atfp  * ( zb_sed_si(:,:) + za_sed_si(:,:) )) + (atfp1 * zn_sed_si(:,:))
-               zn_sed_si(:,:) = za_sed_si(:,:)
-               za_sed_si(:,:) = 0.0
-               !!
-               zb_sed_ca(:,:) = (atfp  * ( zb_sed_ca(:,:) + za_sed_ca(:,:) )) + (atfp1 * zn_sed_ca(:,:))
+               zb_sed_ca(:,:) = za_sed_ca(:,:)
                zn_sed_ca(:,:) = za_sed_ca(:,:)
                za_sed_ca(:,:) = 0.0
             endif
          ENDIF
-      ELSE                                                   !  case of smolar scheme or muscl
-         if (jorgben.eq.1) then
-            zb_sed_n(:,:)  = za_sed_n(:,:)
-            zn_sed_n(:,:)  = za_sed_n(:,:)
-            za_sed_n(:,:)  = 0.0
-            !!
-            zb_sed_fe(:,:) = za_sed_fe(:,:)
-            zn_sed_fe(:,:) = za_sed_fe(:,:)
-            za_sed_fe(:,:) = 0.0
-            !!
-            zb_sed_c(:,:)  = za_sed_c(:,:)
-            zn_sed_c(:,:)  = za_sed_c(:,:)
-            za_sed_c(:,:)  = 0.0
-         endif
-         if (jinorgben.eq.1) then
-            zb_sed_si(:,:) = za_sed_si(:,:)
-            zn_sed_si(:,:) = za_sed_si(:,:)
-            za_sed_si(:,:) = 0.0
-            !!
-            zb_sed_ca(:,:) = za_sed_ca(:,:)
-            zn_sed_ca(:,:) = za_sed_ca(:,:)
-            za_sed_ca(:,:) = 0.0
-         endif
-      ENDIF
       endif
-
+      
       IF( ln_diatrc ) THEN
          !!----------------------------------------------------------------------
